/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var Features = function()
{
	var features = {};
	
	/**
		Initialize the page.
	*/
	features.initPage = function()
	{
		var pageId = Doc.getPageId();
		if (pageId == 'view-page')
		{
			Buttons.addClickHandler('close', App.closeWindow);
		}
		else if (pageId == 'list-page')
		{
			var attributes = {'item-type': 'FEATURE'};
			var tableAttributes = {'table-id': 'features'};
			Buttons.addClickHandler('btnColumns', Buttons.configureColumns, tableAttributes);
			Buttons.addClickHandler('btnExport', Buttons.runListPlugin, tableAttributes);
			Buttons.addClickHandler('btnImport', Buttons.runListPlugin, tableAttributes);
			Buttons.addClickHandler('btnRunPlugin', Buttons.runListPlugin, tableAttributes);
			Buttons.addClickHandler('btnNewReporterList', features.newReporterList);

			TabControl.setSwitchFunction('main', features.switchTab);
			
			Buttons.addClickHandler('close', App.closeWindow);
			Buttons.addClickHandler('btnOk', Buttons.returnSelected, tableAttributes);
		}
	}
	
	features.switchTab = function(event)
	{
		var target = event.target;
		var tabId = target.id.substring(5);

		var frm = document.forms['features'];
		var url = '../index.jsp?ID='+App.getSessionId();
		url += '&cmd=ViewItem&item_id='+frm.arraydesign_id.value;;
		url += '&tab='+tabId;
		location.replace(url);
	}
	
	features.newReporterList = function()
	{
		var controller = Items.getController('REPORTERLIST');
		Table.submitToPopup('features', 'CreateReporterList', controller.width, controller.height);
	}
	
	return features;
}();

Doc.onLoad(Features.initPage);
