/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2020 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var AddItems = function()
{
	var additems = {};
	
	additems.initPage = function()
	{
		// ItemList
		Buttons.addClickHandler('item_id.select', additems.selectList);
		Events.addEventHandler('item_id', 'base-selected', Items.onItemSelected);
		
		// Find out what is selected in the parent form
		var frm = document.forms['additems'];
		var parentForm = Data.get('sourceSelected', 'parent-form');
		var selectedItemsInParentForm = window.opener.Table.getSelected(parentForm)
		if (selectedItemsInParentForm.length == 0)
		{
			Doc.element('sourceSelected').disabled = true;
		}
		else
		{
			Forms.checkRadio(frm.source, 'selected');
			Doc.element('lblSelected').innerHTML += ' ['+selectedItemsInParentForm.length+']';
			Forms.addHidden(frm, 'items', selectedItemsInParentForm.join(','));
		}
		
		// Save + Close buttons
		Buttons.addClickHandler('btnAdd', additems.save);
		Buttons.addClickHandler('close', App.closeWindow);
	}

	additems.selectList = function()
	{
		var frm = document.forms['additems'];
		var url = '&resetTemporary=1';
		url += '&tmpfilter:BOOLEAN:disableManualMembers=0';
		url += '&tmpfilter:INT:memberType='+Data.get('page-data', 'member-type');
		if (frm.item_id.length > 0) 
		{
			var id = Math.abs(parseInt(frm.item_id[0].value));				
			url += '&item_id='+id;
		}
		Dialogs.selectItem('ITEMLIST', 'item_id', 0, url);
	}
	
	// Submit the form
	additems.save = function()
	{
		var frm = document.forms['additems'];
		if (Strings.trim(frm.item_id.value) == '')
		{
			Forms.showNotification(frm.item_id, 'No item list is selected');
			return false;
		}
		frm.submit();
	}
		
	return additems;
}();

Doc.onLoad(AddItems.initPage);
